unit uPlayer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ActnList, Buttons, StdCtrls, OleCtrls, WMPLib_TLB,
  ComCtrls;

type
  TfrmPlayer = class(TForm)
    wmpActions: TActionList;
    wmpPlay: TAction;
    wmpPause: TAction;
    wmpStop: TAction;
    imgList: TImageList;
    edUrl: TEdit;
    btnOpen: TSpeedButton;
    dlgOpen: TOpenDialog;
    wmpOpen: TAction;
    barVolume: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure wmpPlayExecute(Sender: TObject);
    procedure wmpOpenExecute(Sender: TObject);
    procedure wmpPauseExecute(Sender: TObject);
    procedure wmpStopExecute(Sender: TObject);
    procedure barVolumeChange(Sender: TObject);
  private
    { Dclarations prives }
    procedure updateWMPActions;
  public
    { Dclarations publiques }
    WMP : TWindowsMediaPlayer;
  end;

var
  frmPlayer : TfrmPlayer;

implementation

uses uControl;

{$R *.dfm}

procedure TfrmPlayer.updateWMPActions;
begin
  wmpPlay.Enabled   := FileExists(edUrl.Text) and (WMP.playState in [wmppsUndefined, wmppsPaused, wmppsStopped]);
  wmpPause.Enabled  := WMP.PlaySTate in [wmppsPlaying, wmppsTransitioning];
  wmpStop.Enabled   := WMP.PlaySTate in [wmppsPlaying, wmppsPaused, wmppsTransitioning];
end;

procedure TfrmPlayer.FormCreate(Sender: TObject);
begin
  WMP:=TWindowsMediaPlayer.Create(Nil);
  WMP.Visible   := False;
  WMP.settings.autoStart := False;
  WMP.settings.volume:=50;
  barVolume.Position:=50;
  updateWMPActions;  
  frmControl := TfrmControl.Create(Nil);
  frmControl.Show;
end;

procedure TfrmPlayer.FormDestroy(Sender: TObject);
begin
  frmControl.Release;
  WMP.Free;
end;

procedure TfrmPlayer.wmpPlayExecute(Sender: TObject);
begin
  case WMP.playState of
    wmppsUndefined,
    wmppsStopped  : begin
                      WMP.URL:= edUrl.Text;
                      //LabelPisteEnCours.Caption:=WMP.currentMedia.name;
                      WMP.controls.play;
                    end;
    wmppsPaused :   begin
                      WMP.controls.play;
                    end;
  end;
  updateWMPActions;  
end;

procedure TfrmPlayer.wmpOpenExecute(Sender: TObject);
begin
  if dlgOpen.Execute then
  begin
    edUrl.Text  := dlgOpen.FileName;
    updateWMPActions;
  end;
end;

procedure TfrmPlayer.wmpPauseExecute(Sender: TObject);
begin
  WMP.controls.pause;
  updateWMPActions;
end;

procedure TfrmPlayer.wmpStopExecute(Sender: TObject);
begin
  WMP.controls.stop;
  updateWMPActions;
end;

procedure TfrmPlayer.barVolumeChange(Sender: TObject);
begin
  WMP.settings.volume:=barVolume.Position;
end;

end.
 